﻿init python:
    import math
    names = [
    "Roger Griffin", "Thomas Patterson", "Jimmy Edwards", "Steven Bell", "Michelle Garcia", "Virginia Rivera", "Russell Clark", "Carl Hall", "Charles Foster", "Phillip Morgan", "Bobby Evans", "Andrea Thomas", "Nicholas Moore", "Karen Cook", "Steve Rogers", "Mark Jenkins", "Joe King", "Diana Coleman", "Jerry Taylor", "Philip Williams", "Todd Ward", "Katherine Flores", "Robert Thompson", "Tina Ramirez", "Gerald Howard", "Nicole Brown", "Susan Ross", "Albert Stewart", "Ruby Perry", "Roy Hughes", "Frank Washington", "Harry White", "Mary Long", "Julia Torres", "Barbara Rodriguez", "Linda Green", "Victor Wood", "Diane Sanders", "Kathryn Morris", "Raymond Nelson", "Walter Alexander", "Joseph Hill", "Keith Diaz", "Gloria Davis", "Donna Johnson", "Brian Lopez", "Edward Parker", "James Mitchell", "Emily Watson", "Craig Reed", "Ruth Young", "Randy Anderson", "Joan Lewis", "Henry Allen", "Heather Carter", "Peter Jones", "Laura Cooper", "Kathleen Bailey", "Ryan Henderson", "Jason Walker", "Jennifer Adams", "Christopher James", "Sarah Martinez", "Pamela Sanchez", "Lois Brooks", "Cynthia Lee", "Angela Miller", "Jack Roberts", "Johnny Cox", "Elizabeth Bennett", "Stephanie Kelly", "Marilyn Martin", "Norma Richardson", "Anne Harris", "Betty Smith", "Lawrence Butler", "Maria Scott", "Jeremy Turner", "Gary Bryant", "Adam Campbell", "Alice Gonzales", "Scott Phillips", "Douglas Wilson", "Amanda Gray", "Kathy Powell", "Gregory Perez", "David Gonzalez", "Jose Simmons", "Sandra Russell", "Arthur Barnes", "Janet Collins", "Wanda Jackson", "Jeffrey Baker", "Ronald Murphy", "Evelyn Hernandez", "Julie Peterson", "Dennis Price", "Terry Robinson", "Juan Wright", "Jacqueline Doe"
    ]
    avatars = 18
    class base_player:
        def __init__(self, name = None, img = None, cash = 0):
            global names, avatars
            self.name = name or renpy.random.choice(names)
            self.img = img or "greedy pig/avatars/{}.webp".format(renpy.random.randint(0, avatars))
            self.cash = cash
    class greedy_pig_player(base_player):
        def __init__(self, is_ai = True):
            base_player.__init__(self)
            self.score = []
            self.bank = 0
            self.target = renpy.random.randint(10, 25)
            self.is_ai = is_ai

    class greedy_pig_class:
        def __init__(self):
            self.target = 100
            self.turn = 0
            self.players = [greedy_pig_player(False), greedy_pig_player()]
            self.positions = []
            self.pos_calculator()
            self.is_rolling = 0
            self.winner = None
        def pos_calculator(self):
            p = len(self.players)
            angle = 2 * 3.14159 / p
            radius = 400
            result = []
            for i in range(p):
                x = radius * math.cos(angle*i)
                y = radius * math.sin(angle*i)
                result.append((x, y, angle*i))
            self.positions = result
        def add(self, is_ai = False):
            if is_ai:
                self.players.append(greedy_pig_player())
            else:
                self.players.append(greedy_pig_player(False))
            self.pos_calculator()
        def roll(self):
            self.is_rolling = renpy.random.randint(1,6)
        def roll_done(self):
            if self.is_rolling == 1:
                Play("sound", "greedy pig/one.ogg")()
                self.players[self.turn].score = []
                self.next()
            else:
                self.players[self.turn].score.append(self.is_rolling)
            self.is_rolling = 0
        def bank(self):
            if len(self.players[self.turn].score):
                Play("sound", "greedy pig/bank.ogg")()
            s = 0
            for i in self.players[self.turn].score:
                s += i
            self.players[self.turn].bank += s
            self.players[self.turn].score = []
            if self.players[self.turn].bank >= self.target:
                self.winner = self.players[self.turn]
            self.next()
        def next(self):
            self.turn += 1
            if self.turn > len(self.players)-1:
                self.turn = 0
        def ai(self):
            s = 0
            for i in self.players[self.turn].score:
                s += i
            if s >= self.players[self.turn].target or s + self.players[self.turn].bank >= self.target:
                self.bank()
            else:
                self.roll()

default greedy_pig_ins = greedy_pig_class()
screen greedy_pig(g = greedy_pig_ins):
    modal True
    style_prefix "pig"
    drag:
        offset 20,20
        frame:
            background "#000a" padding 10,10 
            vbox:
                spacing 6
                button:
                    text _("Add player")
                    action Function(g.add)
                button:
                    text _("Add AI")
                    action Function(g.add, True)
                button:
                    text _("How to play")
                    action Show("how_to_play_greedy_pig")
    fixed:
        fit_first True align 1.0,0.0 offset -20,20
        add "greedy pig/pig.webp"
        text "Target: {}".format(g.target) align .5,.5
    for p,i in zip(g.positions, g.players):
        frame:
            align .5,.5 padding 10,10 offset p
            if i == g.players[g.turn]:
                background "#6a0a"
            else:
                background "#000a"
            fixed:
                fit_first True
                add i.img
                vbox:
                    spacing 6
                    if p[0] > 0:
                        xoffset 150
                    else:
                        xoffset -150
                    text i.name size 16
                    hbox:
                        text _("Bank: ") size 16
                        text str(i.bank)

    if len(g.players[g.turn].score):
        hbox:
            align .5,.4
            for i in g.players[g.turn].score:
                add "greedy pig/dice/{}.webp".format(i)

    if g.is_rolling:
        add "greedy pig/dice/{}.webp".format(g.is_rolling) align .5,.5
        timer .5 repeat True action Function(g.roll_done)
    elif not g.winner:
        if not g.players[g.turn].is_ai:
            vbox:
                align .5,.6 spacing 6
                button:
                    text _("Roll")
                    action Function(g.roll)
                if len(g.players[g.turn].score):
                    button:
                        text _("Bank")
                        action Function(g.bank)
                else:
                    button:
                        text _("Pass")
                        action Function(g.bank)
        else:
            timer .5 repeat True action Function(g.ai)

    if g.winner:
        # button:
        #     background None
        #     action NullAction()
        frame:
            align (.5,.5) padding (10,10)
            background "#000a"
            vbox:
                spacing 10
                add g.winner.img align .5,.5
                text "{} got enough to buy this pig!".format(g.winner.name)
                button:
                    align .5,.5
                    text "Exit"
                    action Return(g.winner)

screen how_to_play_greedy_pig:
    modal True
    button:
        background "#000a"
        action Hide("how_to_play_greedy_pig")
    frame:
        align (.5,.5) padding (10,10)
        background "#000a" xsize 1000
        vbox:
            spacing 20
            text "How to play Greedy pig" size 40 align .5,.5
            text "On your turn, you roll the dice to get some points, then decide if you want to roll more or bank  the amount you already have and yield the turn.\nYou can roll as many time as you want to get more points but if you roll a one, you'll lose all points and yield the turn to the next player.\nThe first player that reaches the target points wins the pig."
style pig_button:
    align (.5,.5) padding (10,10)
    background "#000a"
label greedy_pig_example:
    show image "greedy pig/bg.webp"
    call screen greedy_pig

